#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <malloc.h>
#include <sys/types.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#define PORTNUMBER  23

int main( int argc, char * argv[] )
{
    char buf[1024];
    char hostname2[64];	
    int s,s2,sm,ns,len,len2,m,rc;
    struct sockaddr_in name;
    struct sockaddr_in name2;
    struct sockaddr_in mc_group;	
    struct hostent *hp2;
    fd_set readfds, readfdsCopy;
    unsigned long int GroupIP;	
    char loop, ttl;

    if (argc != 4)
		{
    	printf("\nSintaxis 'srvTnP' : <Puerto_telnet> <IP_Grupo_Multicast> <Puerto_Multicast>\n\n");
    	exit(0);
	  }	
	printf("Puerto Telnet: %s \n",argv[1]);
	printf("IP Grupo Multicast: %s\n",argv[2]);
	printf("Puerto Multicast: %s\n",argv[3] );

    gethostname(hostname2, sizeof(hostname2));
    hp2 = gethostbyname(hostname2);
	
    /*conexin con telnet por puerto 23*/
    s2 = socket(AF_INET, SOCK_STREAM, 0);
    name2.sin_family = AF_INET;
    name2.sin_port = htons(PORTNUMBER);	 
    memcpy(&name2.sin_addr, hp2->h_addr_list[0], hp2->h_length);   	
    len2 = sizeof(struct sockaddr_in);

     /*conexin con el monitor*/
     if( (GroupIP = inet_addr(argv[2]))== -1)
       printf("error in inet_addr\n");
   mc_group.sin_family = AF_INET;
   mc_group.sin_port = htons(atoi(argv[3]));
   mc_group.sin_addr.s_addr = GroupIP;
   sm = socket (PF_INET,SOCK_DGRAM,0);
   /*if (bind( sm, (struct sockaddr *)&mc_group, sizeof(mc_group)) < 0) {
   fprintf(stderr, "Can't bind ....\n");
   exit (-1);
  }  */
   loop = 1;
   if( setsockopt(sm,IPPROTO_IP,IP_MULTICAST_LOOP,(char *) &loop,
		  sizeof(u_char)) == -1 )
   {
     printf("error in setting loopback\n");
   }

   ttl = 0;
   if( setsockopt(sm,IPPROTO_IP,IP_MULTICAST_TTL,(char *) &ttl,
		  sizeof(u_char)) == -1 )
   {
     printf("error in setting loopback value\n");
   }

    /*conexin con el cliente telnet*/
    s = socket(AF_INET, SOCK_STREAM, 0);
    name.sin_family = AF_INET;
    name.sin_port = htons(atoi(argv[1]));
    name.sin_addr.s_addr = htonl(INADDR_ANY);
    len = sizeof(struct sockaddr_in);
    bind(s, (struct sockaddr *) &name, len);
    listen(s, 5);
    FD_ZERO(&readfdsCopy); 
    FD_SET(s2,&readfdsCopy);
    FD_SET(s,&readfdsCopy);

    for(;;){

    memcpy(&readfds, &readfdsCopy, sizeof(fd_set));    
    m = select(FD_SETSIZE, &readfds, (fd_set *) 0, (fd_set *) 0, NULL); 
    if (m > 0) {	//si hay actividad atiende
                    if (FD_ISSET(s, &readfds)) {	//inicia coneccion con cli
	                                        connect(s2, (struct sockaddr *) &name2, len2); //abrir conexin con telnet
	                                        FD_SET(s2, &readfdsCopy);
	
						ns = accept(s, (struct sockaddr *) &name, &len); //abrir conexin con cliente
                                        	FD_SET(ns, &readfdsCopy);	
							
                                               }
                   /*Recibe paquetes del servidor y enva este al cliente */
                    if (FD_ISSET(s2, &readfds)) {	// si hay paq. de serv. telnet
                                                if ( (rc=recv(s2, buf, sizeof(buf),0)) < 0)
								{perror("receiving stream  message");}
                                                if (rc > 0) {
      		                                            if (send(ns, buf, rc, 0) < 0) //envia servidor a cliente	
       	                                                         {perror("sending stream message");}
							    if (sendto(sm, buf, rc, 0, (struct sockaddr*)&mc_group,
								         sizeof(mc_group)) <0 )
								   perror("sending datagram message");
   								
							    buf[rc]=(char)NULL;			
                                                            printf("%s",buf);	
							    }			
                                                }
                     /*Recibe paquetes del cliente y los enva al servidor telnet*/
                     if (FD_ISSET(ns, &readfds)) {	
                                                if ( (rc=recv(ns, buf, sizeof(buf),0)) <0) //recibe del cliente
							{perror("receiving stream  message");}
                                                if (rc > 0){
							    buf[rc]=(char)NULL;			
                                                            printf("%s",buf);
      		                                            if (send(s2, buf, rc, 0) <0) //envia a srv telnet	
								   { perror("sending stream message");}
                                                            if (sendto(sm, buf, rc, 0, (struct sockaddr*)&mc_group,
								         sizeof(mc_group)) <0 )
								   perror("sending datagram message");
						           		
       	                                                   }
                                                }
						
                } //fin de if

    }    /*fin de for*/
    close(ns);
    close(s2);	
    close(s);
    close(sm);	
    exit(0);
    /*Trmino de conexin con el cliente*/	
}
